// -------------------------------------------------------------------------------
// 
// 		cwCu		t@CANZXvOwb_t@C
// 
// 				Ver 3.23d
// 
// -------------------------------------------------------------------------------

#ifndef DX_FILE_H
#define DX_FILE_H

// CN[h ------------------------------------------------------------------
#include "DxCompileConfig.h"
#include "DxLib.h"
#include "DxStatic.h"
#include "DxHandle.h"
#include <stdarg.h>


// }N` --------------------------------------------------------------------

// CuŎgpt@CANZXp֐
#define DX_FSYNC( handle )							{while( DX_FIDLECHK( handle ) == FALSE ) Thread_Sleep(0);}
#define DX_FOPEN( path )							StreamOpen( (path), FALSE, TRUE, FALSE )
#define DX_FOPENW( path )							StreamOpenW( (path), FALSE, TRUE, FALSE )
#define DX_FOPENT( path )							StreamOpenT( (path), FALSE, TRUE, FALSE )
#define DX_FOPEN_CACHE( path )						StreamOpen( (path),  TRUE, TRUE, FALSE )
#define DX_FOPEN_ASYNC( path )						StreamOpen( (path), FALSE, TRUE,  TRUE )
#define DX_FCLOSE( handle )							StreamClose( (DWORD_PTR)(handle) )
#define DX_FREAD( buf, length, num, handle )		StreamRead( (void *)(buf), (size_t)(length), (size_t)(num), (DWORD_PTR)(handle) )
#define DX_FSEEK( handle, pos, mode )				StreamSeek( (DWORD_PTR)(handle), (LONGLONG)(pos), (int)(mode) )
#define DX_FTELL( handle )							StreamTell( (DWORD_PTR)(handle) )
#define DX_FEOF( handle )							StreamEof( (DWORD_PTR)(handle) )
#define DX_FIDLECHK( handle )						StreamIdleCheck( (DWORD_PTR)(handle) )
#define DX_FISDXA( handle )							StreamIsDXA( (DWORD_PTR)(handle) )
#define DX_FSETDIR( path )							StreamChDir( (path) )
#define DX_FGETDIR( buffer, bufferbytes )			StreamGetDirS( (buffer), (bufferbytes) )
#define DX_FFINDFIRST( path, buffer )				StreamFindFirst( (path), (buffer) )
#define DX_FFINDNEXT( handle, buffer )				StreamFindNext( (DWORD_PTR)(handle), (buffer) )
#define DX_FFINDCLOSE( handle )						StreamFindClose( (DWORD_PTR)(handle) )

// STREAMDATA pwp[`
#define STREAMDATA_READ_BYTE(   stream_data, buffer )		( ( stream_data ).ReadShred.Read( ( buffer ),        1, 1, ( stream_data ).DataPoint ) != 1 ? FALSE : TRUE )
#define STREAMDATA_READ_WORD(   stream_data, buffer )		( ( stream_data ).ReadShred.Read( ( buffer ),        2, 1, ( stream_data ).DataPoint ) != 1 ? FALSE : TRUE )
#define STREAMDATA_READ_DWORD(  stream_data, buffer )		( ( stream_data ).ReadShred.Read( ( buffer ),        4, 1, ( stream_data ).DataPoint ) != 1 ? FALSE : TRUE )
#define STREAMDATA_READ_QWORD(  stream_data, buffer )		( ( stream_data ).ReadShred.Read( ( buffer ),        8, 1, ( stream_data ).DataPoint ) != 1 ? FALSE : TRUE )
#define STREAMDATA_READ_FLOAT(  stream_data, buffer )		( ( stream_data ).ReadShred.Read( ( buffer ),        4, 1, ( stream_data ).DataPoint ) != 1 ? FALSE : TRUE )
#define STREAMDATA_READ_DOUBLE( stream_data, buffer )		( ( stream_data ).ReadShred.Read( ( buffer ),        8, 1, ( stream_data ).DataPoint ) != 1 ? FALSE : TRUE )
#define STREAMDATA_READ_OTHER(  stream_data, buffer, size )	( ( stream_data ).ReadShred.Read( ( buffer ), ( size ), 1, ( stream_data ).DataPoint ) != 1 ? FALSE : TRUE )

// t@CANZXpXbhւ̎w
#define FILEACCESSTHREAD_FUNCTION_OPEN		(0)				// t@CJ
#define FILEACCESSTHREAD_FUNCTION_CLOSE		(1)				// t@C
#define FILEACCESSTHREAD_FUNCTION_READ		(2)				// t@Cǂݍ
#define FILEACCESSTHREAD_FUNCTION_SEEK		(3)				// t@C|C^ړ
#define FILEACCESSTHREAD_FUNCTION_EXIT		(4)				// I

#define FILEACCESSTHREAD_DEFAULT_CACHESIZE	(128 * 1024)	// ftHg̃LbVTCY

// nh^Cv
#define FILEHANDLETYPE_NORMAL				(0)				// ʏ̃t@Cnh
#define FILEHANDLETYPE_FULLYLOAD			(1)				// t@C̓eɓǂݍ񂾏p̃nh

// t@CpX̍ő咷
#define FILEPATH_MAX						(512 * 3)


// ˑ`wb_t@C̃CN[h --------------------------------------

#ifdef WINDOWS_DESKTOP_OS
#include "Windows/DxFileWin.h"
#endif // WINDOWS_DESKTOP_OS

#ifdef __ANDROID__
#include "Android/DxFileAndroid.h"
#endif // __ANDROID__

#ifdef __APPLE__
    #include "TargetConditionals.h"
    #if TARGET_OS_IPHONE
		#include "iOS/DxFileiOS.h"
    #endif // TARGET_OS_IPHONE
#endif // __APPLE__





#ifndef DX_NON_NAMESPACE

namespace DxLib
{

#endif // DX_NON_NAMESPACE

// \̒` --------------------------------------------------------------------

// t@CANZXnh
struct FILEACCESSINFO
{
	HANDLEINFO				HandleInfo ;						// nhʃf[^
	int						HandleType ;						// nh^Cv( FILEHANDLETYPE_NORMAL Ȃ )

	STREAMDATA				StreamData ;						// ǂݍݏpf[^

	int						CharCodeFormat ;					// eLXgt@C̏ꍇ̃R[htH[}bg( 0 ̏ꍇ͖ )

	// FILEHANDLETYPE_NORMAL ł̂ݎgp
	DWORD_PTR				FilePointer ;						// t@C|C^

	// FILEHANDLETYPE_FULLYLOAD ł̂ݎgp
	int						AllocFileImage ;					// t@Cǂݍރ̈mۂǂ( TRUE:mۂ  FALSE:mۂĂȂ )
	void					*FileImage ;						// ǂݍ񂾃t@Ci[̈ւ̃|C^
	LONGLONG				FileSize ;							// t@CTCY
} ;

// t@CANZXp\
struct FILEACCESS
{
	int						EofFlag ;							// I[`FbNtO
	ULONGLONG				Position ;							// ANZXʒu
	ULONGLONG				Size ;								// TCY
	int						UseASyncReadFlag ;					// 񓯊ǂݍ݂sǂ

	FILEACCESS_PF			PF ;								// ˑ
} ;

// t@Cp\
struct FINDINFO
{
	FINDINFO_PF				PF ;								// ˑ
} ;

// t@CANZXgpO[of[^̍\
struct FILEMANAGEDATA
{
	int						InitializeFlag ;					// tO

	FILEMANAGEDATA_PF		PF ;								// ˑ
} ;

// ϐ錾 --------------------------------------------------------------

// t@CANZXgpO[of[^̍\
extern FILEMANAGEDATA GFileData ;

// ftHgXg[t@NV
extern STREAMDATASHREDTYPE2W StreamFunctionW ;

// ֐vg^Cv錾-----------------------------------------------------------

// t@CANZX̏EI֐
extern	int			InitializeFile( void ) ;														// t@CANZX̏
extern	int			TerminateFile( void ) ;															// t@CANZX̌n

// ǂݍݐpt@CANZX֐
extern	DWORD_PTR	ReadOnlyFileAccessOpen( const wchar_t *Path, int UseCacheFlag, int BlockReadFlag, int UseASyncReadFlag  ) ;
extern	int			ReadOnlyFileAccessClose( DWORD_PTR Handle ) ;
extern	LONGLONG	ReadOnlyFileAccessTell( DWORD_PTR Handle ) ;
extern	int			ReadOnlyFileAccessSeek( DWORD_PTR Handle, LONGLONG SeekPoint, int SeekType ) ;
extern	size_t		ReadOnlyFileAccessRead( void *Buffer, size_t BlockSize, size_t DataNum, DWORD_PTR Handle ) ;
extern	int			ReadOnlyFileAccessEof( DWORD_PTR Handle ) ;
extern	int			ReadOnlyFileAccessIdleCheck( DWORD_PTR Handle ) ;
extern	int			ReadOnlyFileAccessIsDXA( DWORD_PTR Handle ) ;
extern	int			ReadOnlyFileAccessChDir( const wchar_t *Path ) ;
extern	int			ReadOnlyFileAccessGetDir( wchar_t *Buffer ) ;
extern	int			ReadOnlyFileAccessGetDirS( wchar_t *Buffer, size_t BufferBytes ) ;
extern	DWORD_PTR	ReadOnlyFileAccessFindFirst( const wchar_t *FilePath, FILEINFOW *Buffer ) ;				// ߂l: -1=G[  -1ȊO=FindHandle
extern	int			ReadOnlyFileAccessFindNext( DWORD_PTR FindHandle, FILEINFOW *Buffer ) ;					// ߂l: -1=G[  0=
extern	int			ReadOnlyFileAccessFindClose( DWORD_PTR FindHandle ) ;									// ߂l: -1=G[  0=

// ݐpt@CANZX֐
extern	int			WriteOnlyFileAccessDelete( const wchar_t *Path ) ;
extern	DWORD_PTR	WriteOnlyFileAccessOpen( const wchar_t *Path ) ;
extern	DWORD_PTR	WriteOnlyFileAccessOpenWCHAR( const char *Path ) ; // Visual C++ 6.0 pɈ char ^ɂ̂
extern	int			WriteOnlyFileAccessClose( DWORD_PTR Handle ) ;
extern	int			WriteOnlyFileAccessSeek( DWORD_PTR Handle, LONGLONG SeekPoint, int SeekType ) ;
extern	int			WriteOnlyFileAccessWrite( DWORD_PTR Handle, void *Buffer, size_t WriteSize, size_t *GetWriteSize = NULL ) ;
extern	int			WriteOnlyFileAccessPrintf( DWORD_PTR Handle, const char *FormatString, ... ) ;

// Xg[f[^ANZX֐
extern	DWORD_PTR	StreamOpen(  const wchar_t *Path,  int UseCacheFlag, int BlockFlag, int UseASyncReadFlag ) ;
extern	DWORD_PTR	StreamOpenW( const char    *PathW, int UseCacheFlag, int BlockFlag, int UseASyncReadFlag ) ; // Visual C++ 6.0 pɈ char ^ɂ̂
extern	DWORD_PTR	StreamOpenT( const TCHAR   *Path,  int UseCacheFlag, int BlockFlag, int UseASyncReadFlag ) ;
extern	int			StreamClose( DWORD_PTR Handle ) ;
extern	LONGLONG	StreamTell( DWORD_PTR Handle ) ;
extern	int			StreamSeek( DWORD_PTR Handle, LONGLONG SeekPoint, int SeekType ) ;
extern	size_t		StreamRead( void *Buffer, size_t BlockSize, size_t DataNum, DWORD_PTR Handle ) ;
extern	int			StreamEof( DWORD_PTR Handle ) ;
extern	int			StreamIdleCheck( DWORD_PTR Handle ) ;
extern	int			StreamIsDXA( DWORD_PTR Handle ) ;
extern	int			StreamChDir(  const wchar_t *Path ) ;
extern	int			StreamChDirT( const TCHAR   *Path ) ;
extern	int			StreamGetDirS(  wchar_t *Buffer, size_t BufferBytes ) ;
extern	int			StreamGetDirTS( TCHAR   *Buffer, size_t BufferBytes ) ;
extern	DWORD_PTR	StreamFindFirst(  const wchar_t *FilePath, FILEINFOW *Buffer ) ;		// ߂l: -1=G[  -1ȊO=FindHandle
extern	DWORD_PTR	StreamFindFirstT( const TCHAR   *FilePath, FILEINFO  *Buffer ) ;		// ߂l: -1=G[  -1ȊO=FindHandle
extern	int			StreamFindNext(  DWORD_PTR FindHandle, FILEINFOW *Buffer ) ;			// ߂l: -1=G[  0=
extern	int			StreamFindNextT( DWORD_PTR FindHandle, FILEINFO  *Buffer ) ;			// ߂l: -1=G[  0=
extern	int			StreamFindClose( DWORD_PTR FindHandle ) ;								// ߂l: -1=G[  0=
extern	const STREAMDATASHREDTYPE2W *StreamGetStruct( void ) ;

// t@C wchar_t ł TCHAR ł̃f[^ϊ֐
extern	int			ConvFileIntoToFileInfoW( FILEINFO  *Src, FILEINFOW *Dest ) ;
extern	int			ConvFileIntoWToFileInfo( FILEINFOW *Src, FILEINFO  *Dest ) ;

// Xg[f[^ANZXp֐\̊֌W
extern	STREAMDATASHRED *GetFileStreamDataShredStruct( void ) ;								// Xg[f[^ǂ݂ݐp֐|C^\̂̃t@Cp\̂𓾂
extern	STREAMDATASHRED *GetMemStreamDataShredStruct( void ) ;								// Xg[f[^ǂ݂ݐp֐|C^\̂ؗp\̂𓾂




// t@Cnh֐
extern	int			FileRead_open_UseGParam( const wchar_t *FilePath, int ASync, int ASyncLoadFlag = FALSE ) ;				// t@CJ
extern	int			FileRead_seek_UseGParam( int FileHandle, LONGLONG Offset, int Origin, int ASyncLoadFlag = FALSE ) ;		// t@C|C^̈ʒuύX
extern	int			FileRead_read_UseGParam( int FileHandle, void *Buffer, int ReadSize, int ASyncLoadFlag = FALSE ) ;		// t@Cf[^ǂݍ
extern	int			FileRead_fullyLoad_UseGParam( const wchar_t *FilePath, int ASyncLoadFlag = FALSE ) ;					// w̃t@C̓eSăɓǂݍ݁Ȁ̃ANZXɕKvȃnhԂ( ߂l  -1:G[  -1ȊO:nh )AgInh FileRead_fullyLoad_delete ō폜Kv܂
extern	int			FileRead_scanf_base(        int         FileHandle, const void  *Format,        va_list Param ) ;	// t@C珑ꂽf[^ǂݏo
extern	int			FileRead_scanf_baseCHAR(    FILEACCESSINFO *FileInfo, const char  *Format,        va_list Param ) ;	// t@C珑ꂽf[^ǂݏo
extern	int			FileRead_scanf_baseUTF16LE( FILEACCESSINFO *FileInfo, const WORD  *FormatUTF16LE, va_list Param ) ;	// t@C珑ꂽf[^ǂݏo



// ɒuꂽf[^t@C̃f[^ɗႦĂ߂̊֐
extern	DWORD_PTR	MemStreamOpen( const void *DataBuffer, size_t DataSize ) ;
extern	int			MemStreamClose( DWORD_PTR StreamDataPoint ) ;



// t@CpX֌W

// tpXł͂ȂpXtpXɕϊ
// ( CurrentDir ̓tpXłKv(Ɂw\xĂĂǂ) )
// ( CurrentDir  NULL ̏ꍇ݂͌̃JgfBNggp )
//extern int			ConvertFullPath_( const char *Src, char *Dest, const char *CurrentDir = NULL ) ; 
extern int			ConvertFullPathA_( const char    *Src, char    *Dest, size_t BufferBytes, const char    *CurrentDir = NULL ) ; 
extern int			ConvertFullPathW_( const wchar_t *Src, wchar_t *Dest, size_t BufferBytes, const wchar_t *CurrentDir = NULL ) ; 
extern int			ConvertFullPathT_( const TCHAR   *Src, TCHAR   *Dest, size_t BufferBytes, const TCHAR   *CurrentDir = NULL ) ; 

// w̃t@CpXw̃tH_pX瑊΃ANZX邽߂̑΃pX쐬
// ( FilePath  StartFolderPath tpXł͂Ȃꍇ͊֐ŃtpX܂ )
// StartFolderPath ̖[ / or \ Ă肠܂
//extern int			CreateRelativePath_( const char *FilePath, const char *StartFolderPath, char *Dest ) ;
extern int			CreateRelativePathW_( const wchar_t *FilePath, const wchar_t *StartFolderPath, wchar_t *Dest, size_t BufferBytes ) ;
extern int			CreateRelativePathT_( const TCHAR   *FilePath, const TCHAR   *StartFolderPath, TCHAR   *Dest, size_t BufferBytes ) ;

// ̃pX񂩂FXȏ擾
// ( CurrentDir ̓tpXłKv(Ɂw\xĂĂǂ) )
// ( CurrentDir  0 ̏ꍇ͎ۂ̃JgfBNggp )
// DirPath ̏I[ɂ \ ͕tȂ
extern int AnalyseFilePathW_(
	const wchar_t *Src,
	wchar_t *FullPath,	size_t FullPathBytes,
	wchar_t *DirPath,	size_t DirPathBytes,
	wchar_t *FileName,	size_t FileNameBytes,
	wchar_t *Name,		size_t NameBytes,
	wchar_t *ExeName,	size_t ExeNameBytes,
	const wchar_t *CurrentDir = 0
) ;
extern int AnalyseFilePathT_(
	const TCHAR *Src,
	TCHAR   *FullPath,	size_t FullPathBytes,
	TCHAR   *DirPath,	size_t DirPathBytes,
	TCHAR   *FileName,	size_t FileNameBytes,
	TCHAR   *Name,		size_t NameBytes,
	TCHAR   *ExeName,	size_t ExeNameBytes,
	const TCHAR *CurrentDir = 0
) ;

// t@CꏏɂȂĂƕĂpXt@CƃfBNgpX𕪊
// tpXłKv͖At@Cłǂ
// DirPath ̏I[  }[N͕tȂ
//extern int		AnalysisFileNameAndDirPath_( const char *Src, char *FileName = 0, char *DirPath = 0 ) ;
extern int			AnalysisFileNameAndDirPathW_( const wchar_t *Src, wchar_t *FileName, size_t FileNameBytes, wchar_t *DirPath, size_t DirPathBytes ) ;
extern int			AnalysisFileNameAndDirPathT_( const TCHAR   *Src, TCHAR   *FileName, size_t FileNameBytes, TCHAR   *DirPath, size_t DirPathBytes ) ;

// t@CpXt@CƊgq擾
//extern int		AnalysisFileNameAndExeName_( const char *Src, char *Name = 0, char *ExeName = 0 ) ;
extern int			AnalysisFileNameAndExeNameW_( const wchar_t *Src, wchar_t *Name, size_t NameBytes, wchar_t *ExeName, size_t ExeNameBytes ) ;
extern int			AnalysisFileNameAndExeNameT_( const TCHAR   *Src, TCHAR   *Name, size_t NameBytes, TCHAR   *ExeName, size_t ExeNameBytes ) ;

// t@CpX̊gqς𓾂
//extern int		GetChangeExeNamePath_( const char *Src, char *Dest, const char *ExeName ) ;

extern void			SetEnMarkT_( TCHAR   *PathBuf, size_t BufferBytes ) ;	// Ɂw\xĂȂꍇ͕t
extern void			SetEnMarkW_( wchar_t *PathBuf, size_t BufferBytes ) ;	// Ɂw\xĂȂꍇ͕t

extern void			ChangeEnMarkToSlashT_( TCHAR   *PathBuf ) ;				// pX񒆂́w\xw/xɕϊ
extern void			ChangeEnMarkToSlashW_( wchar_t *PathBuf ) ;				// pX񒆂́w\xw/xɕϊ

extern int			Strcmp_Str2_WildcardT_( TCHAR   *Str1, TCHAR   *Str2 ) ;	// ̕r( Str2 ɂ̓ChJ[h̎gp\ )
extern int			Strcmp_Str2_WildcardW_( wchar_t *Str1, wchar_t *Str2 ) ;	// ̕r( Str2 ɂ̓ChJ[h̎gp\ )

// nꂽtpXƂĈAhCu( :\ or :/ ̑O܂ )
// ̓lbg[NtH_( \ or / ̑O܂ )擾
// lbg[NtH_ꍇ͍ŏ \\ ܂߂
// ߂l͎擾̒( lbg[NtH_̏ꍇ \\ ʂɊ܂܂܂ )
// Src ̓tpXłKv܂A΃pXł͐ɓ삵܂
//extern int		AnalysisDriveName_( const char *Src, char *Dest ) ;
extern int			AnalysisDriveNameW_( const wchar_t *Src, wchar_t *Dest, size_t BufferBytes ) ;

// nꂽtH_pXƂĈAtH_( \ or / ̑O܂ )擾܂
// n񂪃tpXŁAŏɃhCuĂ琳Ȍʂ܂
// ../ ̉ʃtH_ɍ~镶񂪂ꍇ .. o͂܂
// ߂l͎擾̒ł
//extern int		AnalysisDirectoryName_( const char *Src, char *Dest ) ;
extern int			AnalysisDirectoryNameW_( const wchar_t *Src, wchar_t *Dest, size_t BufferBytes ) ;




// va_list ֐
extern	int			FileRead_scanf_VaList( int FileHandle , const TCHAR *Format , va_list VaList ) ;					// t@C珑ꂽf[^ǂݏo





// ˑp֐

// t@CANZX̏EI֐
extern	int			InitializeFile_PF( void ) ;														// t@CANZX̏֐̊ˑ̏s֐
extern	int			TerminateFile_PF( void ) ;														// t@CANZX̌n֐̊ˑ̏s֐

// t@CANZX֐
extern	int			ReadOnlyFileAccessOpen_PF(		FILEACCESS *FileAccess, const wchar_t *Path, int UseCacheFlag, int BlockReadFlag ) ;
extern	int			ReadOnlyFileAccessClose_PF(		FILEACCESS *FileAccess ) ;
extern	LONGLONG	ReadOnlyFileAccessTell_PF(		FILEACCESS *FileAccess ) ;
extern	int			ReadOnlyFileAccessSeek_PF(		FILEACCESS *FileAccess, LONGLONG SeekPoint ) ;
extern	size_t		ReadOnlyFileAccessRead_PF(		void *Buffer, size_t BlockSize, size_t DataNum, FILEACCESS *FileAccess ) ;
extern	int			ReadOnlyFileAccessIdleCheck_PF(	FILEACCESS *FileAccess ) ;
extern	int			ReadOnlyFileAccessChDir_PF(		const wchar_t *Path ) ;
extern	int			ReadOnlyFileAccessGetDirS_PF(	wchar_t *Buffer, size_t BufferBytes ) ;
extern	int			ReadOnlyFileAccessFindFirst_PF(	FINDINFO *FindInfo, const wchar_t *FilePath, FILEINFOW *Buffer ) ;
extern	int			ReadOnlyFileAccessFindNext_PF(	FINDINFO *FindInfo, FILEINFOW *Buffer ) ;
extern	int			ReadOnlyFileAccessFindClose_PF(	FINDINFO *FindInfo ) ;

// ݐpt@CANZX֐
extern	int			WriteOnlyFileAccessDelete_PF( const wchar_t *Path ) ;
extern	DWORD_PTR	WriteOnlyFileAccessOpen_PF(  const wchar_t *Path ) ;
extern	int			WriteOnlyFileAccessClose_PF( DWORD_PTR Handle ) ;
extern	int			WriteOnlyFileAccessSeek_PF(  DWORD_PTR Handle, LONGLONG SeekPoint, int SeekType ) ;
extern	int			WriteOnlyFileAccessWrite_PF( DWORD_PTR Handle, void *Buffer, size_t WriteSize, size_t *GetWriteSize = NULL ) ;


#ifndef DX_NON_NAMESPACE

}

#endif // DX_NON_NAMESPACE

#endif // DX_FILE_H

