// ----------------------------------------------------------------------------
//
//		cwCu@[r[ĐpvO
//
//				Ver 3.23d
//
// ----------------------------------------------------------------------------

// cwCu쐬p`
#define DX_MAKE

#include "DxMovie.h"

#ifndef DX_NON_MOVIE

// CN[h----------------------------------------------------------------
#include "DxLib.h"
#include "DxStatic.h"
#include "DxBaseFunc.h"
#include "DxMemory.h"
#include "DxSound.h"
#include "DxUseCLib.h"
#include "DxLog.h"

#ifndef DX_NON_NAMESPACE

namespace DxLib
{

#endif // DX_NON_NAMESPACE

// }N`------------------------------------------------------------------

// [r[XVԊu
#define MOVIEREFRESHWAIT		(17)

// [r[nh̗L`FbN
#define MOVIEHCHK( HAND, MPOINT )		HANDLECHK(       DX_HANDLETYPE_MOVIE, HAND, *( ( HANDLEINFO ** )&MPOINT ) )
#define MOVIEHCHK_ASYNC( HAND, MPOINT )	HANDLECHK_ASYNC( DX_HANDLETYPE_MOVIE, HAND, *( ( HANDLEINFO ** )&MPOINT ) )

#define VFW_E_NOT_FOUND                  ((HRESULT)0x80040216L)

#define MOVIE MovieGraphManageData

// \̌^錾----------------------------------------------------------------

// f[^錾------------------------------------------------------------------

MOVIEGRAPHMANAGE MovieGraphManageData ;								// ֘Af[^

// NX錾 -----------------------------------------------------------------

// ֐vg^Cv錾--------------------------------------------------------

// vOR[h------------------------------------------------------------

// [r[֘ÅǗ̏
extern int InitializeMovieManage( void )
{
	if( MOVIE.InitializeFlag == TRUE )
		return -1 ;

	// nhǗ̏
	InitializeHandleManage( DX_HANDLETYPE_MOVIE, sizeof( MOVIEGRAPH ), MAX_MOVIE_NUM, InitializeMovieHandle, TerminateMovieHandle, L"Movie" ) ;

	// ˑ̏s
	if( InitializeMovieManage_PF() < 0 )
	{
		return -1 ;
	}

	// tOĂ
	MOVIE.InitializeFlag = TRUE ;

	// I
	return 0 ;
}

// [r[֘ÅǗ̌n
extern int TerminateMovieManage( void )
{
	if( MOVIE.InitializeFlag == FALSE )
		return -1 ;

	// ˑ̌ns
	if( TerminateMovieManage_PF() < 0 )
	{
		return -1 ;
	}

	// nhǗ̌n
	TerminateHandleManage( DX_HANDLETYPE_MOVIE ) ;

	// tO|
	MOVIE.InitializeFlag = FALSE ;

	// I
	return 0 ;
}

// OPENMOVIE_GPARAM ̃f[^Zbg
extern void Graphics_Image_InitOpenMovieGParam( OPENMOVIE_GPARAM *GParam )
{
	GParam->RightAlphaFlag = MOVIE.RightAlphaFlag ;
	GParam->A8R8G8B8Flag = MOVIE.A8R8G8B8Flag ;
	GParam->NotUseYUVFormatSurfaceFlag = MOVIE.NotUseYUVFormatSurfaceFlag ;
}

// [r[t@CI[v
extern int OpenMovie( const wchar_t *FileName, int *Width, int *Height, int SurfaceMode )
{
	OPENMOVIE_GPARAM GParam ;

	Graphics_Image_InitOpenMovieGParam( &GParam ) ;

	return OpenMovie_UseGParam( -1, &GParam, FileName, NULL, 0, Width, Height, FALSE, SurfaceMode ) ;
}

// [r[nh֐
extern int InitializeMovieHandle( HANDLEINFO *HandleInfo )
{
	MOVIEGRAPH *Movie = ( MOVIEGRAPH * )HandleInfo ;

#ifndef DX_NON_FILTER
	Movie->YGrHandle  = -1 ;
	Movie->UVGrHandle = -1 ;
#endif // DX_NON_FILTER

	// I
	return 0 ;
}

// [r[nȟns֐
extern int TerminateMovieHandle( HANDLEINFO *HandleInfo )
{
	MOVIEGRAPH *Movie = ( MOVIEGRAPH * )HandleInfo ;

#ifndef DX_NON_FILTER
	if( Movie->YGrHandle >= 0 )
	{
		NS_DeleteGraph( Movie->YGrHandle, FALSE ) ;
		Movie->YGrHandle = -1 ;
	}

	if( Movie->UVGrHandle >= 0 )
	{
		NS_DeleteGraph( Movie->UVGrHandle, FALSE ) ;
		Movie->UVGrHandle = -1 ;
	}
#endif // DX_NON_FILTER

	// ˑ
	TerminateMovieHandle_PF( HandleInfo ) ;

#ifndef DX_NON_OGGTHEORA
	//  Theora gpĂꍇ͂̊Js
	if( Movie->TheoraFlag )
	{
		TheoraDecode_Terminate( Movie->TheoraHandle ) ;

		if( Movie->TheoraStreamData )
		{
			if( Movie->TheoraStreamDataIsFileImage == FALSE )
			{
				DX_FCLOSE( Movie->TheoraStreamData ) ;
			}
			else
			{
				MemStreamClose( Movie->TheoraStreamData ) ;
			}
			Movie->TheoraStreamData = 0 ;
		}

#ifndef DX_NON_SOUND
		NS_DeleteSoundMem( Movie->TheoraVorbisHandle, FALSE ) ;
		Movie->TheoraVorbisHandle = 0 ;
#endif // DX_NON_SOUND
		Movie->TheoraHandle = 0 ;
		Movie->TheoraFlag = 0 ;
	}
#endif // DX_NON_OGGTHEORA

	if( Movie->NowImage.GraphData != NULL )
	{
		if( Movie->NowImageGraphOutAlloc == FALSE )
		{
			DXFREE( Movie->NowImage.GraphData ) ;
		}
		Movie->NowImage.GraphData = NULL ;
	}

	// I
	return 0 ;
}

// OpenMovie ̃O[oϐɃANZXȂo[W
extern int OpenMovie_UseGParam(
	int GrHandle,
	OPENMOVIE_GPARAM *GParam,
	const wchar_t *FileName,
	const void *FileImage,
	size_t FileImageSize,
	int *Width,
	int *Height,
	int SurfaceMode,
	int ImageSizeGetOnly,
	int ASyncThread
)
{
	int NewHandle ;
	MOVIEGRAPH * Movie ;

	// nh̍쐬
	NewHandle = AddHandle( DX_HANDLETYPE_MOVIE, ASyncThread, -1 ) ;
	if( NewHandle < 0 )
	{
		return -1 ;
	}

	if( MOVIEHCHK_ASYNC( NewHandle, Movie ) )
	{
		return -1 ;
	}

	// gpĂOtBbNnhZbg
	Movie->ParentGrHandle = GrHandle ;

	// EAt@ƂĈtOZbg
	Movie->RightAlpha = GParam->RightAlphaFlag ;

	// 32bitJ[tH[}bg̓ A8R8G8B8 `ƂĈǂ̃tOZbg
	Movie->A8R8G8B8Flag = GParam->A8R8G8B8Flag ;

	// YUVtH[}bg̃T[tFXgpȂǂ̃tOZbg
	Movie->NotUseYUVFormatSurfaceFlag = GParam->NotUseYUVFormatSurfaceFlag ;

#ifndef DX_NON_OGGTHEORA
	STREAMDATASHRED *UseStreamDataShred ;
	// Ogg Theora ƂăI[v悤ƂĂ݂
	if( FileName != NULL )
	{
		Movie->TheoraStreamData = DX_FOPEN( FileName ) ;
		UseStreamDataShred = GetFileStreamDataShredStruct() ;
		Movie->TheoraStreamDataIsFileImage = FALSE ;
	}
	else
	{
		Movie->TheoraStreamData = MemStreamOpen( ( void *)FileImage, FileImageSize ) ;
		UseStreamDataShred = GetMemStreamDataShredStruct() ;
		Movie->TheoraStreamDataIsFileImage = TRUE ;
	}
	Movie->TheoraHandle = TheoraDecode_InitializeStream(
		UseStreamDataShred,
		Movie->TheoraStreamData,
		20,
		Movie->NotUseYUVFormatSurfaceFlag,
		Movie->NotUseYUVFormatSurfaceFlag,
		ASyncThread
	) ;
	if( Movie->TheoraHandle == 0 )
	{
		Movie->TheoraSetupGraphHandleImage = FALSE ;
		if( Movie->TheoraStreamDataIsFileImage == FALSE )
		{
			DX_FCLOSE( Movie->TheoraStreamData ) ;
		}
		else
		{
			MemStreamClose( Movie->TheoraStreamData ) ;
		}
		Movie->TheoraStreamData = 0 ;
	}
	if( Movie->TheoraHandle != 0 )
	{
		THEORADECODE_INFO Info ;

		// 𖄂߂
		TheoraDecode_GetInfo( Movie->TheoraHandle, &Info ) ;
		Movie->Width  = Info.Width ;
		Movie->Height = Info.Height ;
		if( Width  ) *Width  = Info.Width ;
		if( Height ) *Height = Info.Height ;
		Movie->TheoraFrameRate = Info.FrameRate ;
		Movie->TheoraTotalFrame = Info.TotalFrame ;
		Movie->TheoraTotalPlayTime = _DTOL( 1000.0 / Info.FrameRate * Info.TotalFrame ) ;

#ifndef DX_NON_SOUND
		if( ImageSizeGetOnly == FALSE )
		{
			LOADSOUND_GPARAM LoadSoundGParam ;

			InitLoadSoundGParam( &LoadSoundGParam ) ;

			// J Thera p̃ZbgAbvs

			// TEhĐpɃTEhf[^ƂĂǂݍ
			LoadSoundGParam.NotInitSoundMemDelete = TRUE ;
			LoadSoundGParam.OggVorbisFromTheoraFile = TRUE ;
			LoadSoundGParam.DisableReadSoundFunctionMask = ~DX_READSOUNDFUNCTION_OGG ;
			if( FileName != NULL )
			{
				LoadSoundGParam.CreateSoundDataType = DX_SOUNDDATATYPE_FILE ;
				Movie->TheoraVorbisHandle = LoadSoundMemBase_UseGParam( &LoadSoundGParam, FileName, 1, -1, FALSE, ASyncThread ) ;
			}
			else
			{
				LoadSoundGParam.CreateSoundDataType = DX_SOUNDDATATYPE_MEMPRESS ;
				Movie->TheoraVorbisHandle = LoadSoundMemByMemImageBase_UseGParam( &LoadSoundGParam, TRUE, -1, FileImage, FileImageSize, 1, -1, FALSE, ASyncThread ) ;
			}
			Movie->TheoraVorbisTotalTime = ( int )NS_GetSoundTotalTime( Movie->TheoraVorbisHandle ) ;
			Movie->TheoraVorbisFrequency = NS_GetFrequencySoundMem( Movie->TheoraVorbisHandle ) ;

			// [v^Cv̌( قɂ )
			Movie->TheoraLoopType = Movie->TheoraVorbisTotalTime > Movie->TheoraTotalPlayTime ? 1 : 0 ;
		}
		else
		{
			Movie->TheoraVorbisHandle = -1 ;
		}

#else // DX_NON_SOUND
		// [v^Cv͓f[^킹
		Movie->TheoraLoopType = 0 ;
#endif // DX_NON_SOUND

		// Đx̏
		Movie->TheoraPlaySpeedRate = 1.0 ;

		// Theora gpĂtO𗧂Ă
		Movie->TheoraFlag = 1 ;

		// gpׂ BASEIMAGE Zbg
		Movie->UseNowImage = ( BASEIMAGE * )TheoraDecode_GetBaseImage( Movie->TheoraHandle ) ;

		// T[tFX[h̓m[}ƂƂ
		Movie->SurfaceMode = DX_MOVIESURFACE_NORMAL ;
	}
	else
#endif // DX_NON_OGGTHEORA
	{
		// Ogg Theora ȊO̓̓̍Đ͂łȂ
		if( FileName == NULL )
		{
			DXST_LOGFILE_ADDUTF16LE( "\xe0\x30\xfc\x30\xd3\x30\xfc\x30\xd5\x30\xa1\x30\xa4\x30\xeb\x30\xaa\x30\xfc\x30\xd7\x30\xf3\x30\xe6\x51\x06\x74\x42\x66\x6b\x30\x31\x59\x57\x65\x57\x30\x7e\x30\x57\x30\x5f\x30\x00"/*@ L"[r[t@CI[vɎs܂" @*/ ) ;
			goto ERR ;
		}

		// I[vłȂˑ̓t@CI[v݂
		if( OpenMovie_UseGParam_PF( Movie, GParam, FileName, Width, Height, SurfaceMode, ImageSizeGetOnly, ASyncThread ) == -1 )
		{
			DXST_LOGFILE_ADDUTF16LE( "\xe0\x30\xfc\x30\xd3\x30\xfc\x30\xd5\x30\xa1\x30\xa4\x30\xeb\x30\xaa\x30\xfc\x30\xd7\x30\xf3\x30\xe6\x51\x06\x74\x42\x66\x6b\x30\xa8\x30\xe9\x30\xfc\x30\x4c\x30\x7a\x76\x1f\x75\x57\x30\x7e\x30\x57\x30\x5f\x30\x00"/*@ L"[r[t@CI[vɃG[܂" @*/ ) ;
			goto ERR ;
		}
		Movie->Width  = Movie->NowImage.Width  ;
		Movie->Height = Movie->NowImage.Height ;

		// gpׂ BASEIMAGE Zbg
		Movie->UseNowImage = &Movie->NowImage ;
	}

	// 摜XVꂽtO|
	Movie->NowImageUpdateFlag = FALSE ;

	// ꎞ~tO𗧂Ă
	Movie->SysPauseFlag = 1 ;

	// ĐtO|
	Movie->PlayFlag = FALSE ;

	// Đ^Cv̓obNOEhɂĂ
	Movie->PlayType = DX_PLAYTYPE_BACK ;

#ifndef DX_NON_ASYNCLOAD
	if( ASyncThread )
	{
		DecASyncLoadCount( NewHandle ) ;
	}
#endif // DX_NON_ASYNCLOAD

	// nhԂ
	return NewHandle ;

ERR :
#ifndef DX_NON_ASYNCLOAD
	if( ASyncThread )
	{
		DecASyncLoadCount( NewHandle ) ;
	}
#endif // DX_NON_ASYNCLOAD

	CloseMovie( NewHandle ) ;

	// G[I
	return -1 ;
}

// [r[OtBbNI
extern int CloseMovie( int MovieHandle )
{
	return SubHandle( MovieHandle ) ;
}

// [r[̍ĐJn
extern int PlayMovie_( int MovieHandle, int PlayType, int SysPlay )
{
	MOVIEGRAPH * Movie ;

	// [r[f[^nh擾
	if( MOVIEHCHK( MovieHandle, Movie ) )
		return -1 ;

	// PlayType  -1 ̏ꍇ͕ύXȂ
	if( PlayType == -1 ) PlayType = Movie->PlayType ;

	// PlayType  DX_PLAYTYPE_NORMAL w肵ꍇ DX_PLAYTYPE_BACK ɂȂ
	if( PlayType == DX_PLAYTYPE_NORMAL ) PlayType = DX_PLAYTYPE_BACK ;

	// ꎞ~tO|Ă牽Ȃ
	if( Movie->SysPauseFlag == 0 ) return 0 ;

	if( SysPlay == 1 && Movie->PlayFlag == FALSE ) return 0 ;

	// 摜XVꂽtO|
	Movie->NowImageUpdateFlag = FALSE ;

	// ꎞ~tO|
	Movie->SysPauseFlag = 0 ;

	// Đ^Cvۑ
	Movie->PlayType = PlayType ;

	// ĐtO𗧂Ă
	Movie->PlayFlag = TRUE ;

#ifndef DX_NON_OGGTHEORA
	// Theora gpĂ邩ǂŏ𕪊
	if( Movie->TheoraFlag )
	{
		int CurFrame ;
		THEORADECODE_INFO Info ;

		// ĐJn̎Ԃ擾
//		Movie->TheoraPlayTime = NS_GetNowHiPerformanceCount( FALSE ) ;

		// ĐJn̎Ԃ擾
		Movie->TheoraPrevTimeCount = NS_GetNowHiPerformanceCount( FALSE ) ;

		// ĐԂZbg
		TheoraDecode_GetInfo( Movie->TheoraHandle, &Info ) ;
		CurFrame = TheoraDecode_GetCurrentFrame( Movie->TheoraHandle ) ;
		Movie->TheoraPlayNowTime = _DTOL( 1000000.0 / Movie->TheoraFrameRate * CurFrame ) ;

		// ɍĐς݂̃t[OɍĐƂɂ
//		TheoraDecode_GetInfo( Movie->TheoraHandle, &Info ) ;
//		CurFrame = TheoraDecode_GetCurrentFrame( Movie->TheoraHandle ) ;
//		Movie->TheoraPlayTime -= _DTOL( 1000000.0 / Movie->TheoraFrameRate * CurFrame ) ;

		// Vorbis ̍ĐJn
#ifndef DX_NON_SOUND
//		NS_SetSoundCurrentTime( _DTOL( 1000.0 / Movie->TheoraFrameRate * CurFrame ), Movie->TheoraVorbisHandle ) ; 
		NS_PlaySoundMem( Movie->TheoraVorbisHandle, Movie->TheoraLoopType == 1 ? PlayType : DX_PLAYTYPE_BACK, FALSE ) ;
#endif // DX_NON_SOUND
	}
	else
#endif // DX_NON_OGGTHEORA
	{
		// ˑ̍Đs
		PlayMovie__PF( Movie, PlayType, SysPlay ) ;
	}

	// I
	return 0 ;
}

// [r[̍ĐXgbv
extern int PauseMovie( int MovieHandle, int SysPause )
{
	MOVIEGRAPH * Movie ;

	// [r[f[^nh擾
	if( MOVIEHCHK( MovieHandle, Movie ) )
		return -1 ;

	// ꎞ~tOĂȂɂȂ
	if( Movie->SysPauseFlag == 1 )
		return 0 ;

#ifndef DX_NON_OGGTHEORA
	// Theora gpĂ邩ǂŏ𕪊
	if( Movie->TheoraFlag )
	{
		// Theora gpĂꍇ

		// Vorbis ̍Đ~
#ifndef DX_NON_SOUND
		NS_StopSoundMem( Movie->TheoraVorbisHandle ) ;
#endif // DX_NON_SOUND

		// ݂̍Đԕ܂Ńt[i߂Ă
		UpdateMovie( MovieHandle ) ;
	}
	else
#endif // DX_NON_OGGTHEORA
	{
		// ˑ̍Đ~
		if( PauseMovie_PF( Movie, SysPause ) < 0 )
		{
			return 0 ;
		}
	}

	// ꎞ~tO𗧂Ă
	Movie->SysPauseFlag = 1 ;

	// ĐtO|
	if( SysPause == 0 )
	{
		Movie->PlayFlag = FALSE ;
	}

	// I
	return 0 ;
}

// [r[̃t[i߂A߂Ƃ͏oȂ( [r[~ԂŁA Ogg Theora ̂ݗL )
extern int AddMovieFrame( int MovieHandle, unsigned int FrameNum )
{
	MOVIEGRAPH * Movie ;

	// [r[f[^nh擾
	if( MOVIEHCHK( MovieHandle, Movie ) )
		return -1 ;

	// 摜XVꂽtO|
	Movie->NowImageUpdateFlag = FALSE ;

#ifndef DX_NON_OGGTHEORA
	// Ogg Theora ł͂ȂύXłȂ
	if( Movie->TheoraFlag == FALSE )
		return -1 ;

	// ĐύXłȂ
	if( GetMovieState( MovieHandle ) == TRUE )
		return -1 ;

	// ĐʒuύX
	TheoraDecode_IncToFrame( Movie->TheoraHandle, ( int )FrameNum ) ;

	// I
	return 0 ;
#else // DX_NON_OGGTHEORA
	return -1 ;
#endif // DX_NON_OGGTHEORA
}

// [r[̍Đʒuݒ肷(~bP)
extern int SeekMovie( int MovieHandle, int Time )
{
	MOVIEGRAPH * Movie ;

	// [r[f[^nh擾
	if( MOVIEHCHK( MovieHandle, Movie ) )
		return -1 ;

	// 摜XVꂽtO|
	Movie->NowImageUpdateFlag = FALSE ;

#ifndef DX_NON_OGGTHEORA
	// Theora gpĂ邩ǂŏ𕪊
	if( Movie->TheoraFlag )
	{
		int CurFrame ;
		THEORADECODE_INFO Info ;

		// w莞ԂĐԈȏ̒lꍇ̓G[I
		if( Movie->TheoraTotalPlayTime <= Time )
		{
			return -1 ;
		}

		// Ro[gʒuύX
		TheoraDecode_SeekToTime( Movie->TheoraHandle, Time * 1000 ) ;

		// ĐJn^CύX
//		Movie->TheoraPlayTime = NS_GetNowHiPerformanceCount( FALSE ) ;
		TheoraDecode_GetInfo( Movie->TheoraHandle, &Info ) ;
		CurFrame = TheoraDecode_GetCurrentFrame( Movie->TheoraHandle ) ;
		Movie->TheoraPlayNowTime = _DTOL( 1000000.0 / Movie->TheoraFrameRate * CurFrame ) ;
//		Movie->TheoraPlayTime -= _DTOL( 1000000.0 / Movie->TheoraFrameRate * CurFrame ) ;
	
		// ĐʒuύX
#ifndef DX_NON_SOUND
		if( Movie->PlayFlag )
		{
			NS_StopSoundMem( Movie->TheoraVorbisHandle ) ;
		}
		NS_SetSoundCurrentTime( Time, Movie->TheoraVorbisHandle ) ;
		if( Movie->PlayFlag )
		{
			NS_PlaySoundMem( Movie->TheoraVorbisHandle, DX_PLAYTYPE_BACK, FALSE ) ;
		}
#endif // DX_NON_SOUND
	}
	else
#endif // DX_NON_OGGTHEORA
	{
		// ˑ
		if( SeekMovie_PF( Movie, Time ) < 0 )
		{
			return -1 ;
		}
	}

	// I
	return 0 ;
}

// [r[̍Đxݒ肷( 1.0 = {  2.0 = Q{ )Aꕔ̃t@CtH[}bĝ݂ŗLȋ@\ł
extern int SetPlaySpeedRateMovie( int MovieHandle, double SpeedRate )
{
	MOVIEGRAPH * Movie ;

	// [r[f[^nh擾
	if( MOVIEHCHK( MovieHandle, Movie ) )
		return -1 ;

#ifndef DX_NON_OGGTHEORA
	// Theora gpĂ邩ǂŏ𕪊
	if( Movie->TheoraFlag )
	{
		Movie->TheoraPlaySpeedRate = SpeedRate ;
#ifndef DX_NON_SOUND
		if( Movie->TheoraVorbisHandle != -1 )
		{
			NS_SetFrequencySoundMem( _DTOL( Movie->TheoraVorbisFrequency * Movie->TheoraPlaySpeedRate ), Movie->TheoraVorbisHandle ) ;
		}
		else
#endif // DX_NON_SOUND
		{
		}
	}
	else
#endif // DX_NON_OGGTHEORA
	{
		// ˑ
		if( SetPlaySpeedRateMovie_PF( Movie, SpeedRate ) < 0 )
		{
			return 0 ;
		}
	}

	// I
	return 0 ;
}

// [r[̍ĐԂ𓾂
extern int GetMovieState( int MovieHandle )
{
	MOVIEGRAPH * Movie ;

	// [r[f[^nh擾
	if( MOVIEHCHK( MovieHandle, Movie ) )
	{
		return -1 ;
	}

#ifndef DX_NON_OGGTHEORA
	// TheoragpĂ邩ǂŏ𕪊
	if( Movie->TheoraFlag )
	{
		return Movie->PlayFlag ;
	}
	else
#endif // DX_NON_OGGTHEORA
	{
		// ˑ
		return GetMovieState_PF( Movie ) ;
	}
}

// [r[̃{[Zbg(0`10000)
extern int SetMovieVolume( int Volume, int MovieHandle )
{
	MOVIEGRAPH * Movie ;

	// [r[f[^nh擾
	if( MOVIEHCHK( MovieHandle, Movie ) )
		return -1 ;

#ifndef DX_NON_OGGTHEORA
	// Theora gpĂ邩ǂŏ𕪊
	if( Movie->TheoraFlag )
	{
		// Vorbis TEh̉ʂZbg
#ifndef DX_NON_SOUND
		NS_SetVolumeSoundMem( Volume, Movie->TheoraVorbisHandle ) ;
#endif // DX_NON_SOUND
	}
	else
#endif // DX_NON_OGGTHEORA
	{
		// ˑ
		if( SetMovieVolume_PF( Movie, Volume ) < 0 )
		{
			return 0 ;
		}
	}

	// I
	return 0 ;
}

// [r[̊{C[Wf[^擾
extern BASEIMAGE *GetMovieBaseImage( int MovieHandle, int *ImageUpdateFlag, int ImageUpdateFlagSetOnly )
{
	MOVIEGRAPH * Movie ;

	// [r[f[^nh擾
	if( MOVIEHCHK( MovieHandle, Movie ) )
		return NULL ;

#ifndef DX_NON_OGGTHEORA
	// Theora gpĂ邩ǂŏ𕪊
	if( Movie->TheoraFlag )
	{
		// [r[̃t[XV
		UpdateMovie( MovieHandle ) ;

		// NowImage ̓eXVꂽǂ̃tO
		if( ImageUpdateFlag != NULL )
		{
			*ImageUpdateFlag = Movie->NowImageUpdateFlag ;
		}
		Movie->NowImageUpdateFlag = FALSE ;

		// Theora ̃C[WԂ
		return ImageUpdateFlagSetOnly ? NULL : ( BASEIMAGE * )TheoraDecode_GetBaseImage( Movie->TheoraHandle ) ;
	}
#endif // DX_NON_OGGTHEORA

	// gpĂȂꍇ͊ˑ̏s
	return GetMovieBaseImage_PF( Movie, ImageUpdateFlag, ImageUpdateFlagSetOnly ) ;
}

// [r[̑t[𓾂( Ogg Theora ł̂ݗL )
extern int GetMovieTotalFrame( int MovieHandle )
{
	MOVIEGRAPH * Movie ;

	// [r[f[^nh擾
	if( MOVIEHCHK( MovieHandle, Movie ) )
		return -1 ;

#ifndef DX_NON_OGGTHEORA
	// Theora gpĂ邩ǂŏ𕪊
	if( Movie->TheoraFlag )
	{
		// t[Ԃ
		return Movie->TheoraTotalFrame ;
	}
#endif // DX_NON_OGGTHEORA

	// gpĂȂꍇ͊ˑ̏s
	return GetMovieTotalFrame_PF( Movie ) ;
}

// [r[̍Đʒu擾(~bP)
extern int TellMovie( int MovieHandle )
{
	MOVIEGRAPH * Movie ;
	
	// [r[f[^nh擾
	if( MOVIEHCHK( MovieHandle, Movie ) )
		return -1 ;

#ifndef DX_NON_OGGTHEORA
	// Theora gpĂ邩ǂŏ𕪊
	if( Movie->TheoraFlag )
	{
		THEORADECODE_INFO Info ;

		TheoraDecode_GetInfo( Movie->TheoraHandle, &Info ) ;

		// t[XV
		UpdateMovie( MovieHandle ) ;

		// t[ĐԂo
		return _DTOL( TheoraDecode_GetCurrentFrame( Movie->TheoraHandle ) * 1000 / Movie->TheoraFrameRate ) ;
	}
#endif // DX_NON_OGGTHEORA

	// gpĂȂꍇ͊ˑ̏s
	return TellMovie_PF( Movie ) ;
}
 
// [r[̍Đʒu擾(t[P)
extern int TellMovieToFrame( int MovieHandle )
{
	MOVIEGRAPH * Movie ;
	
	// [r[f[^nh擾
	if( MOVIEHCHK( MovieHandle, Movie ) )
		return -1 ;

#ifndef DX_NON_OGGTHEORA
	// Theora ǂŏ𕪊
	if( Movie->TheoraFlag )
	{
		THEORADECODE_INFO Info ;

		TheoraDecode_GetInfo( Movie->TheoraHandle, &Info ) ;

		// t[XV
		UpdateMovie( MovieHandle ) ;

		// ݂̃t[Ԃ
		return TheoraDecode_GetCurrentFrame( Movie->TheoraHandle ) ;
	}
#endif // DX_NON_OGGTHEORA

	// gpĂȂꍇ͊ˑ̏s
	return TellMovieToFrame_PF( Movie ) ;
}

// [r[̍Đʒuݒ肷(t[P)
extern int SeekMovieToFrame( int MovieHandle, int Frame )
{
	MOVIEGRAPH * Movie ;
//	D_OAFilterState State ;
	
	// [r[f[^nh擾
	if( MOVIEHCHK( MovieHandle, Movie ) )
		return -1 ;

	// 摜XVꂽtO|
	Movie->NowImageUpdateFlag = FALSE ;

#ifndef DX_NON_OGGTHEORA
	// Theora ǂŏ𕪊
	if( Movie->TheoraFlag )
	{
		int CurFrame ;
		THEORADECODE_INFO Info ;

		// w莞Ԃt[ȏ̏ꍇ̓G[
		if( Movie->TheoraTotalFrame <= Frame )
		{
			return -1 ;
		}

		// Ro[gʒuύX
		TheoraDecode_SeekToFrame( Movie->TheoraHandle, Frame ) ;

		// ĐJn^CύX
//		Movie->TheoraPlayTime = NS_GetNowHiPerformanceCount( FALSE ) ;
		TheoraDecode_GetInfo( Movie->TheoraHandle, &Info ) ;
		CurFrame = TheoraDecode_GetCurrentFrame( Movie->TheoraHandle ) ;
		Movie->TheoraPlayNowTime = _DTOL( 1000000.0 / Movie->TheoraFrameRate * CurFrame ) ;
//		Movie->TheoraPlayTime -= _DTOL( 1000000.0 / Movie->TheoraFrameRate * CurFrame ) ;
	
		// ĐʒuύX
#ifndef DX_NON_SOUND
		if( Movie->PlayFlag )
		{
			NS_StopSoundMem( Movie->TheoraVorbisHandle ) ;
		}
		NS_SetSoundCurrentTime( _DTOL( Frame * 1000 / Movie->TheoraFrameRate ), Movie->TheoraVorbisHandle ) ;
		if( Movie->PlayFlag )
		{
			NS_PlaySoundMem( Movie->TheoraVorbisHandle, FALSE, TRUE ) ;
		}
#endif // DX_NON_SOUND
	}
	else
#endif // DX_NON_OGGTHEORA
	{
		// ˑ̏s
		SeekMovieToFrame_PF( Movie, Frame ) ;
	}

	// I
	return 0 ;
}

// [r[̂Pt[̎Ԃ𓾂
extern LONGLONG GetOneFrameTimeMovie( int MovieHandle )
{
	MOVIEGRAPH * Movie ;
	
	// [r[f[^nh擾
	if( MOVIEHCHK( MovieHandle, Movie ) )
		return -1 ;

#ifndef DX_NON_OGGTHEORA
	// Theora ǂŏ𕪊
	if( Movie->TheoraFlag )
	{
		THEORADECODE_INFO Info ;

		TheoraDecode_GetInfo( Movie->TheoraHandle, &Info ) ;
		return _DTOL( 1000000 / Movie->TheoraFrameRate ) ;
	}
#endif // DX_NON_OGGTHEORA

	// ˑ̏s
	return GetOneFrameTimeMovie_PF( Movie ) ;
}

// [r[OtBbÑf[^擾
extern MOVIEGRAPH * GetMovieData( int MovieHandle )
{
	MOVIEGRAPH * Movie ;
	
	if( MOVIEHCHK( MovieHandle, Movie ) )
		return NULL ;

	return Movie ;
}


// [r[ŎgpĂT[tFX̉s
extern int ReleaseMovieSurface( int MovieHandle )
{
	MOVIEGRAPH * Movie ;
	
	if( MOVIEHCHK( MovieHandle, Movie ) )
		return -1 ;

#ifndef DX_NON_OGGTHEORA
	if( Movie->TheoraFlag )
	{
		TheoraDecode_SurfaceTerminate( Movie->TheoraHandle ) ;
	}
	else
#endif
	{
	}

	// I
	return 0 ;
}

// [r[̍XVs
extern int UpdateMovie( int MovieHandle, int AlwaysFlag )
{
	MOVIEGRAPH * Movie ;
//	LONGLONG NowFrame, OldFrame ;
	
	// [r[f[^nh擾
	if( MOVIEHCHK( MovieHandle, Movie ) )
		return -1 ;

#ifndef DX_NON_OGGTHEORA
	// Theora gpĂ邩ǂŏ𕪊
	if( Movie->TheoraFlag )
	{
		// Theora gpĂꍇ
		int NowFrame, CurFrame, AddFrame ;
		LONGLONG NowTime ;
		THEORADECODE_INFO Info ;

		// Theora ̏擾
		TheoraDecode_GetInfo( Movie->TheoraHandle, &Info ) ;

		// ̍Đԕt[i߂
		if( Movie->SysPauseFlag == 0 )
		{
			// ĐԂ͉Lȏꍇ͉擾
#ifndef DX_NON_SOUND
/*			if( Movie->TheoraVorbisHandle != -1 && NS_CheckSoundMem( Movie->TheoraVorbisHandle ) == 1 )
			{
				NowTime = NS_GetSoundCurrentTime( Movie->TheoraVorbisHandle ) * 1000 ;
				NowFrame = _DTOL( ( double )( NowTime * Movie->TheoraFrameRate ) / 1000000 ) ;

				// 特擾ꍇ́Af̍őt[𒴂Ă܂ꍇ͌݃t[f̍őt[ɂ
				if( NowFrame >= Info.TotalFrame )
				{
					NowFrame = Info.TotalFrame - 1 ;
				}
			}
			else*/
#endif // DX_NON_SOUND
			{
				LONGLONG Temp64_1, Temp64_2 ;
				DWORD Temp128[ 4 ] ;

				NowTime = NS_GetNowHiPerformanceCount( FALSE ) ;

				// ĐςݎԂi߂
				if( Movie->TheoraPlaySpeedRate < 0.999999999 || Movie->TheoraPlaySpeedRate > 1.0000000001 )
				{
					Temp64_1 = NowTime - Movie->TheoraPrevTimeCount ;
					Temp64_2 = _DTOL( Movie->TheoraPlaySpeedRate * 0x10000 ) ;
					_MUL128_1( ( DWORD * )&Temp64_1, ( DWORD * )&Temp64_2, Temp128 ) ;

					Temp64_2 = 0x10000 ;
					_DIV128_1( Temp128, ( DWORD * )&Temp64_2, ( DWORD * )&Temp64_1 ) ;

					Movie->TheoraPlayNowTime += Temp64_1 ;
				}
				else
				{
					Movie->TheoraPlayNowTime += NowTime - Movie->TheoraPrevTimeCount ;
				}

				Movie->TheoraPrevTimeCount = NowTime ;

				// ݂̃t[̎Zo
				{
					Temp64_1 = Movie->TheoraPlayNowTime ;
					Temp64_2 = _DTOL( Movie->TheoraFrameRate * 0x10000 ) ;
					_MUL128_1( ( DWORD * )&Temp64_1, ( DWORD * )&Temp64_2, Temp128 ) ;

					Temp64_2 = LL_NUM( 65536000000 ) /* 1000000 * 0x10000 */ ;
					_DIV128_1( Temp128, ( DWORD * )&Temp64_2, ( DWORD * )&Temp64_1 ) ;

					NowFrame = ( int )Temp64_1 ;
//					NowFrame = _DTOL( ( double )( ( NowTime - Movie->TheoraPlayTime ) * Movie->TheoraFrameRate ) / 1000000 ) ;
				}

				// [vw肪邩ǂőt[𒴂Ăꍇ̏𕪊򂷂
				if( Info.TotalFrame <= NowFrame )
				{
					if( Movie->PlayType & DX_PLAYTYPE_LOOPBIT )
					{
						// [vꍇ͑t[Ŋ]o
						NowFrame %= Info.TotalFrame ;
					}
					else
					{
						// [vȂꍇ͍ŏIt[Ŏ~܂
						NowFrame = Info.TotalFrame - 1 ;
					}
				}
			}

			// [r[̍Đt[擾
			CurFrame = TheoraDecode_GetCurrentFrame( Movie->TheoraHandle ) ;

			// ]̃t[݃obt@Ɋi[Ăt[ƈႤꍇ̓obt@XV
			if( CurFrame != NowFrame )
			{
				Movie->NowImageUpdateFlag = TRUE ;

				// Zt[Zo
				if( NowFrame < CurFrame )
				{
					// [vꍇ
					AddFrame = Info.TotalFrame - CurFrame + NowFrame ;

#ifndef DX_NON_SOUND
					// [vꍇŁAĐ^Cv̏ꍇ̓TEhēxĐJn
					if( Movie->TheoraLoopType == 0 )
					{
						NS_PlaySoundMem( Movie->TheoraVorbisHandle, DX_PLAYTYPE_BACK, TRUE ) ;
					}
#endif // DX_NON_SOUND
				}
				else
				{
					AddFrame = NowFrame - CurFrame ;
				}

				// t[i߂
				TheoraDecode_IncToFrame( Movie->TheoraHandle, AddFrame ) ;

				// ŏIXVԂۑ
				Movie->RefreshTime = NowTime ;
			}
			else
			{
				// ]̃t[t[I[ɒBĂĊ[vwłTEhꍇ͂ōĐI
				if( NowFrame == Info.TotalFrame - 1 &&
					( Movie->PlayType & DX_PLAYTYPE_LOOPBIT ) == 0
#ifndef DX_NON_SOUND
					&& ( Movie->TheoraVorbisHandle == -1 || NS_CheckSoundMem( Movie->TheoraVorbisHandle ) != 1 )
#endif // DX_NON_SOUND
					)
				{
					Movie->PlayFlag = FALSE ;

					// ꎞ~tO𗧂Ă
					Movie->SysPauseFlag = 1 ;
				}
			}
		}

		// C[W̍\z
		if( Movie->UpdateFunction )
		{
			Movie->UpdateFunction( Movie, Movie->UpdateFunctionData ) ;

			// ŏ̍XVsꂽtOZbg
			Movie->FirstUpdateFlag = TRUE ;
		}
	}
	else
#endif
	{
		// ˑs
		UpdateMovie_PF( Movie, AlwaysFlag ) ;
	}

	// I
	return 0 ;
}

// [r[̍XVɌĂяoR[obN֐o^
extern int SetCallbackMovie( int MovieHandle, void ( *Callback )( MOVIEGRAPH *Movie, void *Data ), void *Data )
{
	MOVIEGRAPH *Movie ;

	// [r[f[^nh擾
	if( MOVIEHCHK( MovieHandle, Movie ) )
		return -1 ;

	// AhXZbg
	Movie->UpdateFunction = Callback ;
	Movie->UpdateFunctionData = Data ;

	// I
	return 0 ;
}

// [r[̍ĐԂ~
extern int DisableMovieAll( void )
{
	// o[Wł͓ɉȂ
	return 0 ;

#if 0
	MOVIEGRAPH *Movie ;
	int i ;

	if( MOVIE.InitializeFlag == FALSE )
		return -1 ;

	// ׂẴ[r[ɂďs
	for( i = HandleManageArray[ DX_HANDLETYPE_MOVIE ].AreaMin ; i <= HandleManageArray[ DX_HANDLETYPE_MOVIE ].AreaMax ; i ++ )
	{
		Movie = ( MOVIEGRAPH * )HandleManageArray[ DX_HANDLETYPE_MOVIE ].Handle[ i ] ;
		if( Movie == NULL ) continue ;

#ifndef DX_NON_OGGTHEORA
		// Theora gpĂ邩ǂŏ𕪊
		if( Movie->TheoraFlag )
		{
			// Ȃ
/*
			// ꎞ~tO|Ă珈
			if( Movie->SysPauseFlag == 0 )
			{
				// Vorbis ̍Đ~
				NS_StopSoundMem( Movie->TheoraVorbisHandle ) ;

				// ݂̍Đԕ܂Ńt[i߂Ă
				{
					int NowFrame, CurFrame ;
					LONGLONG NowTime ;
					THEORADECODE_INFO Info ;

					// Theora ̏擾
					TheoraDecode_GetInfo( Movie->TheoraHandle, &Info ) ;

					// ̍Đԕt[i߂
					NowTime = NS_GetNowHiPerformanceCount( FALSE ) ;
					NowFrame = _DTOL( ( double )( ( NowTime - Movie->TheoraPlayTime ) * Movie->TheoraFrameRate ) / 1000000 ) ;
					CurFrame = TheoraDecode_GetCurrentFrame( Movie->TheoraHandle ) ;
					if( CurFrame != NowFrame )
					{
						if( NowFrame < CurFrame )
						{
							TheoraDecode_SeekToFrame( Movie->TheoraHandle, NowFrame ) ;
						}
						else
						{
							TheoraDecode_IncToFrame( Movie->TheoraHandle, NowFrame - CurFrame ) ;
						}
					}

					// C[W̍\z
					TheoraDecode_SetupImage( Movie->TheoraHandle ) ;
				}

				// ꎞ~tO𗧂Ă
				Movie->SysPauseFlag = 1 ;
			}
*/		}
		else
#endif
#ifndef DX_NON_DSHOW_MOVIE
		{
/*			if( Movie )
			{
				// ݂̍ĐԂۑ
				Movie->pMediaSeeking->GetCurrentPosition( &Movie->BackUpTime ) ;

				// ebnlIuWFNgI

				if( Movie->pMediaControl		){ Movie->pMediaControl->Release() ;		Movie->pMediaControl = NULL ;		}
				if( Movie->pMediaSeeking		){ Movie->pMediaSeeking->Release() ;		Movie->pMediaSeeking = NULL ;		}
				if( Movie->pBasicAudio			){ Movie->pBasicAudio->Release() ;			Movie->pBasicAudio = NULL ;			}
				if( Movie->pMovieImage			){ Movie->pMovieImage->Release() ;			Movie->pMovieImage = NULL ;			}
				if( Movie->pFilter				){ Movie->pFilter->Release() ;				Movie->pFilter = NULL ;				}
				if( Movie->pGraph				){ Movie->pGraph->Release() ;				Movie->pGraph = NULL ;				}
			}
*/		}
#else  // DX_NON_DSHOW_MOVIE
		{
		}
#endif
	}

	// I
	return 0 ;
#endif
}


// [r[̍ĐԂ𕜌
extern int RestoreMovieAll( void )
{
	// o[Wł͓ɉȂ
	return 0 ;

#if 0

	MOVIEGRAPH *Movie ;
	int i ;

	if( MOVIE.InitializeFlag == FALSE )
		return -1 ;

	// ׂẴ[r[ɂďs
	for( i = HandleManageArray[ DX_HANDLETYPE_MOVIE ].AreaMin ; i <= HandleManageArray[ DX_HANDLETYPE_MOVIE ].AreaMax ; i ++ )
	{
		Movie = ( MOVIEGRAPH * )HandleManageArray[ DX_HANDLETYPE_MOVIE ].Handle[ i ] ;
		if( Movie == NULL ) continue ;

#ifndef DX_NON_OGGTHEORA
		// Theora ǂŏ𕪊
		if( Movie->TheoraFlag )
		{
			// Ȃ
/*
			// ĐtOĂꍇ̂ݏ
			if( Movie->PlayFlag )
			{
				// ꎞ~tOĂ珈
				if( Movie->SysPauseFlag == 1 )
				{
					int CurFrame ;
					THEORADECODE_INFO Info ;

					// ĐJn̎Ԃ擾
					Movie->TheoraPlayTime = NS_GetNowHiPerformanceCount( FALSE ) ;

					// ɍĐς݂̃t[OɍĐƂɂ
					TheoraDecode_GetInfo( Movie->TheoraHandle, &Info ) ;
					CurFrame = TheoraDecode_GetCurrentFrame( Movie->TheoraHandle ) ;
					Movie->TheoraPlayTime -= _DTOL( 1000000.0 / Movie->TheoraFrameRate * CurFrame ) ;

					// Vorbis ̍ĐJn
					NS_PlaySoundMem( Movie->TheoraVorbisHandle, DX_PLAYTYPE_BACK, FALSE ) ;

					// ꎞ~tO|
					Movie->SysPauseFlag = 0 ;
				}
			}
*/
		}
		else
#endif
#ifndef DX_NON_DSHOW_MOVIE
		{
		}
#else // DX_NON_DSHOW_MOVIE
		{
		}
#endif
	}

	// I
	return 0 ;
#endif  
}

// ׂẴ[r[OtBbNX^[g
extern int PlayMovieAll( void )
{
	MOVIEGRAPH *Movie ;
	int i ;

	if( MOVIE.InitializeFlag == FALSE )
		return -1 ;

	for( i = HandleManageArray[ DX_HANDLETYPE_MOVIE ].AreaMin ; i <= HandleManageArray[ DX_HANDLETYPE_MOVIE ].AreaMax ; i ++ )
	{
		Movie = ( MOVIEGRAPH * )HandleManageArray[ DX_HANDLETYPE_MOVIE ].Handle[ i ] ;
		if( Movie == NULL ) continue ; 

		PlayMovie_( Movie->HandleInfo.Handle, -1, 1 ) ;
	}

	// I
	return 0 ;
}

// ׂẴ[r[OtBbNXgbv
extern int PauseMovieAll( void )
{
	MOVIEGRAPH *Movie ;
	int i ;

	if( MOVIE.InitializeFlag == FALSE )
		return -1 ;

	for( i = HandleManageArray[ DX_HANDLETYPE_MOVIE ].AreaMin ; i <= HandleManageArray[ DX_HANDLETYPE_MOVIE ].AreaMax ; i ++ )
	{
		Movie = ( MOVIEGRAPH * )HandleManageArray[ DX_HANDLETYPE_MOVIE ].Handle[ i ] ;
		if( Movie == NULL ) continue ; 

		PauseMovie( Movie->HandleInfo.Handle, 1 ) ;
	}

	// I
	return 0 ;
}

// t@C̉EAt@ƂĈǂZbg( TRUE:At@ƂĈ )
extern int NS_SetMovieRightImageAlphaFlag( int Flag )
{
	MOVIE.RightAlphaFlag = Flag;
	return TRUE;
}

// ǂݍޓt@C32bitJ[ꍇAA8R8G8B8 `ƂĈǂZbgA
// 32bitJ[ł͂Ȃt@Cɑ΂Ă͖( Flag  TRUE:A8R8G8B8ƂĈ  FALSE:X8R8G8B8ƂĈ( ftHg ) )
extern int NS_SetMovieColorA8R8G8B8Flag( int Flag )
{
	MOVIE.A8R8G8B8Flag = Flag;
	return TRUE;
}

// xtutH[}bg̃T[tFXgpłꍇ͂xtutH[}bg̃T[tFXgp邩ǂݒ肷( TRUE:gp( ftHg ) FALSE:qfatH[}bg̃T[tFXgp )
extern int NS_SetMovieUseYUVFormatSurfaceFlag( int Flag )
{
	MOVIE.NotUseYUVFormatSurfaceFlag = Flag ? FALSE : TRUE ;
	return TRUE;
}


#ifndef DX_NON_NAMESPACE

}

#endif // DX_NON_NAMESPACE

#endif
